<!DOCTYPE html>
<html>

<head>
  <meta charset="utf-8" name="viewport" content="width=device-width, initial-scale=1">
  <!-- Jquery && Bootstrap CDN -->
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
  <!-- DataTable CDN -->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.13.6/css/dataTables.bootstrap4.min.css">
  <script src="https://cdn.datatables.net/1.13.6/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.13.6/js/dataTables.bootstrap4.min.js"></script>
  <!-- Font Awesome CDN -->
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.4.2/css/all.min.css"
    integrity="sha512-z3gLpd7yknf1YoNbCzqRKc4qyor8gaKU1qmn+CShxbuBusANI9QpRohGBreCFkKxLhei6S9CQXFEbbKuqLg0DA=="
    crossorigin="anonymous" referrerpolicy="no-referrer" />
</head>

<body>
  <div class="container-fluid">
    <h1 style="text-align: center;">F100-QUẢN TRỊ NGƯỜI DÙNG</h1>
    <div class="container-fluid jumbotron " style="display: flex;">
      <div class="col col-sm-3 col-md-3 col-lg-3">
        <label for="filter-role">Role</label>
      </div>
      <div class="col col-sm-6 col-md-6 col-lg-6">
        <select id="filter-role" class="form-control">
          <option value="0">---Chọn tất cả---</option>
        </select>
      </div>
      <div class="col col-sm-3 col-md-3 col-lg-3">
        <button id="btn-filter" class="btn btn-primary">Lọc dữ liệu</button>
      </div>
    </div>
    <table class="table-bordered table table-hover table-tripped" id="user-table">
      <thead class="thead-dark">
        <tr>
          <th>STT</th>
          <th>Username</th>
          <th>Firstname</th>
          <th>Lastname</th>
          <th>Email</th>
          <th>Age</th>
          <th>Role</th>
          <th>Action</th>
        </tr>
      </thead>
      <tbody id="user-table-body"></tbody>
    </table>
  </div>
  <script>
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    // Mảng gUserObjects là mảng chứa dữ liệu users
    var gUserObjects = [
      {
        id: 2,
        username: "quannv",
        firstname: "Ngo Van",
        lastname: "Quan",
        age: 18,
        email: "quan@gmail.com",
        roleId: 5
      },
      {
        id: 3,
        username: "longdh",
        firstname: "Do Hoang",
        lastname: "Long",
        age: 19,
        email: "long@gmail.com",
        roleId: 8
      },
      {
        id: 4,
        username: "hiendt",
        firstname: "Do Thi",
        lastname: "Hien",
        age: 29,
        email: "hien@gmail.com",
        roleId: 11
      },
      {
        id: 6,
        username: "lanht",
        firstname: "Ho Thi",
        lastname: "Lan",
        age: 27,
        email: "lan@gmail.com",
        roleId: 13
      }
    ];
    // Mảng gRoleObjects là mảng chứa dữ liệu các roles
    var gRoleObjects = [
      {
        roleId: 5,
        roleName: "Admin"
      },
      {
        roleId: 8,
        roleName: "Manager"
      },
      {
        roleId: 11,
        roleName: "Teacher"
      },
      {
        roleId: 13,
        roleName: "Staff"
      }
    ];
    var gStt = 1
    var gTable = $("#user-table").DataTable({
      // Phân trang
      paging: true,
      // Tìm kiếm
      searching: false,
      // Sắp xếp
      ordering: false,
      // Số bản ghi phân trang
      lengthChange: false,
      columns: [
        { data: "STT" },
        { data: "username" },
        { data: "firstname" },
        { data: "lastname" },
        { data: "age" },
        { data: "email" },
        { data: "roleId" },
        { data: "action" },
      ],
      columnDefs: [
        {
          targets: 0,
          render: function () {
            return gStt++
          }
        },
        {
          targets: 6,
          render: renderRole
        },
        {
          targets: 7,
          defaultContent: `<button class="btn btn-dice">
            <i class="fa-solid fa-dice"></i>
        </button>
        <button class="btn btn-gift">
          <i class="fa-solid fa-gift"></i>
        </button>`
        }
      ]
    })
    /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
    $(document).ready(function () {
      onPageLoading()
      //Gán sự kiện nút filter
      $(document).on("click", "#btn-filter", function () {
        onBtnFilterClick()
      })
      // Gán sự kiện cho icon Dice
      $(document).on("click", ".btn-dice", function () {
        onBtnDiceClick(this)
      })

    })
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onPageLoading() {
      displayDataToTable(gUserObjects)
      loadDataToSelect()
    }
    // Hàm xử lý sự kiện nút lọc
    function onBtnFilterClick() {
      var vFilter = { roleId: -1 }
      // B1 Thu thập dữ liệu
      getDataToFilter(vFilter)
      // B2 Kiểm tra dữ liệu
      // B3 Xử lý Filter
      filterRole(vFilter)

    }
    // Hàm xử lý nút dice
    function onBtnDiceClick(paramBtn) {
      var vRowSelected = $(paramBtn).parents("tr")
      var vDataRow = gTable.row(vRowSelected).data()
      window.location.href = `diceHistory.html?username=${vDataRow.username}
      &firstname=${vDataRow.firstname}&lastname=${vDataRow.lastname}`
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // Hàm render RoleId thành RoleName
    function renderRole(paramRoleId) {
      var vVitriHienTai = 0
      var vRoleObject = null
      var vTimThayRole = false
      while (vTimThayRole == false && vVitriHienTai < gRoleObjects.length) {
        if (gRoleObjects[vVitriHienTai].roleId == paramRoleId) {
          vTimThayRole = true
          vRoleObject = gRoleObjects[vVitriHienTai].roleName

        }
        vVitriHienTai++
      }
      return vRoleObject
    }

    // Hàm load vào bảng
    function displayDataToTable(paramObject) {
      gTable.clear();
      gTable.rows.add(paramObject);
      gTable.draw();
    }
    // Hàm thu thập dữ liệu để lọc
    function getDataToFilter(paramObject) {
      paramObject.roleId = $.trim($("#filter-role").val())
    }
    // Hàm xử lý Filter
    function filterRole(paramObject) {
      var vRoleResult = []
      // Thực hiện việc lọc
      vRoleResult = gUserObjects.filter(function (paramOrder) {
        return (paramObject.roleId == 0 || paramOrder.roleId == paramObject.roleId)
      })
      displayDataToTable(vRoleResult)
    }
    // Hàm load dữ liệu vào select
    function loadDataToSelect() {
      var vRoleSelect = $("#filter-role");
      for (let bI = 0; bI < gRoleObjects.length; bI++) {
        var bPizzaTypeOption = $("<option/>", {
          text: gRoleObjects[bI].roleName,
          value: gRoleObjects[bI].roleId
        }).appendTo(vRoleSelect);
      }
    }
    //
  </script>
</body>

</html>